$(document).ready(function() {
    
});

function get_extrapolation_query(host, service, track, count)
{
    var options = dataoptions[host];
    var query = {
        host: host,
        service: service,
        track: track,
        options: options,
        cmd: 'extrapolate'
    }
    
    return query;
}

function fill_table(d, c)
{
    var tbody = $('#capacityreport-tbody-' + c);
    
    var tr = $('<tr>');
    $('<td>', {text: 'Data Integrity (Not NaN)'}).appendTo(tr);
    $('<td>', {text: parseFloat((d.integrity) * 100).toFixed(2) + '%'}).appendTo(tr);
    tr.appendTo(tbody);
    
    var tr = $('<tr>');
    $('<th>', {text: 'The Recent Past', colspan: 999}).appendTo(tr);
    tr.appendTo(tbody);
    
    var tr = $('<tr>');
    $('<td>', {text: 'Recent Maximum Value'}).appendTo(tr);
    $('<td>', {text: parseFloat(d.dmax).toFixed(2) + d.unit}).appendTo(tr);
    tr.appendTo(tbody);
    
    var tr = $('<tr>');
    $('<td>', {text: 'Recent Average Value'}).appendTo(tr);
    $('<td>', {text: parseFloat(d.dmean).toFixed(2) + d.unit}).appendTo(tr);
    tr.appendTo(tbody);
    
    var tr = $('<tr>');
    $('<th>', {text: 'The Extrapolated Future', colspan: 999}).appendTo(tr);
    tr.appendTo(tbody);
    
    var tr = $('<tr>');
    $('<td>', {text: 'Extrapolated Maximum Value'}).appendTo(tr);
    $('<td>', {text: parseFloat(d.emax).toFixed(2) + d.unit}).appendTo(tr);
    tr.appendTo(tbody);
    
    var tr = $('<tr>');
    $('<td>', {text: 'Extrapolated Average Value'}).appendTo(tr);
    $('<td>', {text: parseFloat(d.emean).toFixed(2) + d.unit}).appendTo(tr);
    tr.appendTo(tbody);
    
    var tr = $('<tr>');
    $('<th>', {text: 'Past vs Future Analysis', colspan: 999}).appendTo(tr);
    tr.appendTo(tbody);
    
    var ami = ((d.emean/d.dmean) - 1) * 100;
    
    if(ami != ami) {
        ami = 0;
    }
    
    if(ami < 0) {
        var amodifier = '-';
    } else {
        var amodifier = '+';
    }
    
    var mmi = ((d.emax/d.dmax) - 1) * 100;
    
    if(mmi != mmi) {
        mmi = 0;
    }
    
    if(mmi < 0) {
        var mmodifier = '-';
    } else {
        var mmodifier = '+';
    }
    
    var tr = $('<tr>');
    $('<td>', {text: 'Average will change'}).appendTo(tr);
    $('<td>', {text: amodifier + parseFloat(Math.abs(ami)).toFixed(2) + '%'}).appendTo(tr);
    tr.appendTo(tbody);
    
    var tr = $('<tr>');
    $('<td>', {text: 'Maximum will change'}).appendTo(tr);
    $('<td>', {text: mmodifier + parseFloat(Math.abs(mmi)).toFixed(2) + '%'}).appendTo(tr);
    tr.appendTo(tbody);
    
    /** The following is code for the value at data functionality which 
     * has been removed for now. It remains here as scar tissue in order to
     * get started on it again in the future.
     *
     * var tr = $('<tr>');
     * $('<th>', {text: 'Date Value Projections', colspan: 999}).appendTo(tr);
     * tr.appendTo(tbody);
     *  
     * $.each(d.dates, function(i, d) {
     * var date = d.date;
     * var value = d.value;
     * var tr = $('<tr>');
     * $('<td>', {text: date}).appendTo(tr);
     * $('<td>', {text: value}).appendTo(tr);
     * tr.appendTo(tbody);
     * });
     */
}

function make_highcharts(series_data, host, service, track, uid, error, width, height)
{
    var renderdiv = 'highcharts-target-' + uid;
    var title = track + ' for ' + service + ' on ' + host;

    var tracking = true;
    if (getURLParameters('hideoptions') == "1") {
        tracking = false;
    }

    Highcharts.setOptions({
        global: { useUTC: false },
    });

    var chart = new Highcharts.Chart({
        chart: {
            renderTo: renderdiv,
            zoomType: 'x',
            spacingRight: 20,
            height: height,
            width: width,
            animation: false
        },
        credits: {
            enabled: false
        },
        title: {
            text: title
        },
        xAxis: {
            type: 'datetime',
            maxZoom: 300000,
            title: {
                text: null
            }
        },
        yAxis: {
            title: {
                text: ''
            },
            min: 0,
            startOnTick: false,
            showFirstLabel: false
        },
        tooltip: {
            formatter: function() {
                var h = Highcharts.dateFormat('%m/%d/%Y %H:%M', this.x);
                h += '<br/>' + this.series.name + ': <b>' + (this.point.y).toFixed(3) + '</b>';
                return h;
            }
        },
        legend: {
            enabled: true
        },
        plotOptions: {
            series: {
                fillOpacity: .5,
                animation: false,
                shadow: false,
                enableMouseTracking: tracking
            },
            area: {
                lineWidth: 1,
                marker: {
                    enabled: false,
                    states: {
                        hover: {
                            enabled: true,
                            radius: 5
                        }
                    }
                },
                shadow: false,
                states: {
                    hover: {
                        lineWidth: 1
                    }
                }
            }
        },
        series: series_data
    });
    if(error) {
        chart.showLoading('No data to display: ' + error);
    }
}

function getURLParameters(paramName) 
{
        var sURL = window.document.URL.toString();  
    if (sURL.indexOf("?") > 0)
    {
       var arrParams = sURL.split("?");         
       var arrURLParams = arrParams[1].split("&");      
       var arrParamNames = new Array(arrURLParams.length);
       var arrParamValues = new Array(arrURLParams.length);     
       var i = 0;
       for (i=0;i<arrURLParams.length;i++)
       {
        var sParam =  arrURLParams[i].split("=");
        arrParamNames[i] = sParam[0];
        if (sParam[1] != "")
            arrParamValues[i] = unescape(sParam[1]);
        else
            arrParamValues[i] = "No Value";
       }

       for (i=0;i<arrURLParams.length;i++)
       {
                if(arrParamNames[i] == paramName){
            //alert("Param:"+arrParamValues[i]);
                return arrParamValues[i];
             }
       }
       return "No Parameters Found";
    }

}